   use32 
   org  0x0 

 ; HEADER ====================================================================== 
   db  'MENUET01' 
   dd  0x01 
   dd  START 
   dd  I_END 
   dd  0x7000 
   dd  0x7000 
   dd  0x0 
   dd  0x0 

include 'MACROS.INC';

 START: 
 ; EVENT ======================================================================= 
 red: 
     call draw_window 
 still: 
     mov     eax,10                        ;  10 -   
     int     0x40                          ;  ( )  

     cmp     eax,1                         ;   ? 
     je      red                           ;   -   red 
     cmp     eax,2                         ;   ? 
     je      key                           ;   -  key 
     cmp     eax,3                         ;   ? 
     je      button                        ;   -  button 
     jmp     still                         ;    -    
 ;end_still 

 key:                    ;     
     mcall   2                             ;  2 -    ( ah) 
     jmp     still                         ;     
 ;end_key 

 button: 
     mcall   17                            ; 17 -     
     cmp     ah, 1                         ;      1, 
     jz      bexit                         ;  
     jmp     still 
   bexit: 
     mcall -1                    ;    
 ;end_button 

 ; DRAW ======================================================================== 
 draw_window: 
     mov     eax,12                        ;  12: ,     
     mov     ebx,1                         ; 1,  
     int     0x40                          ;  

     mov     eax,48                        ;  48 -    
     mov     ebx,3                         ;  3 -    . 
     mov     ecx,sc                        ;     edx ,   
     mov     edx,sizeof.system_colors      ;    (  40 ) 
     int     0x40                          ;  

     mov     eax,48                        ;  48 -   . 
     mov     ebx,4                         ;  4 -  eax =  . 
     int     0x40                          ;  
     mov     ecx,eax                       ;    

     xor     eax,eax                       ;  eax (mov eax,0) ( 0) 
     mov     ebx,200 shl 16+160            ; [   x]*65536 + [   x] 
     add     ecx,200 shl 16+60             ;   + [  y]*65536 + [  y] 
     mov     edx,[sc.work]                 ;      
     or      edx,0x34000000                ;       
     mov     edi,title                     ;   
     int     0x40                          ;  

     mov     eax,12                        ;  12: ,     
     mov     ebx,2                         ; 1,  
     int     0x40                          ;  

     ret 

 ; DATA ======================================================================== 
     sc           system_colors 
     title        db 'DEMO REC',0 

 I_END: